<!-- eslint-disable vue/no-parsing-error -->
<script lang="ts" setup>
import { computed, nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import type { Checkwork } from '@/types/CheckWork'
import http from '@/services/http'
import { useLoadingStore } from '@/stores/loading'
import checkworkService from '@/services/checkwork'
import { useCheckworkStore } from '@/stores/checkwork'
import { useRoleStore } from '@/stores/role'
import { useAuthStore } from '@/stores/auth'
import type { AxiosResponse } from 'axios'
import checkwork from '@/services/checkwork'
const authStore = useAuthStore()
const checkworkStore = useCheckworkStore()
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Full Name',
    key: 'fullname',
    value: 'fullname'
  },
  {
    title: 'Date',
    key: 'date',
    value: 'date'
  },
  {
    title: 'Timein',
    key: 'timein',
    value: 'timein'
  },
  {
    title: 'Timeout',
    key: 'timeout',
    value: 'timeout'
  },
  {
    title: 'Status',
    key: 'status',
    value: 'status'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const loadingStore = useLoadingStore()
const roleStore = useRoleStore()
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const dialogEr = ref(false)
const dialogSuctimein = ref(false)
const dialogNothavetimein = ref(false)
const dialoghavetimeinandtimeout = ref(false)
const loading = ref(false)
const roles = ref()
const currentTime = ref<string>('')
const currentDate = ref<string>('')
const historydate = ref(false)
const date = ref<Date | null>(null)

let editedIndex = -1
let lastId = 4
function onSubmit() { }
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    checkworkStore.clearForm()
  })
}
async function deleteItemConfirm() {
  // Delete item from list
  await checkworkStore.deleteCheckwork()
  closeDelete()
}
async function editItem(item: Checkwork) {
  if (!item.id) return
  await checkworkStore.getCheckWork(item.id)
  dialog.value = true
}
async function deleteItem(item: Checkwork) {
  if (!item.id) return
  await checkworkStore.getCheckWork(item.id)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    checkworkStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await checkworkStore.saveCheckwork()
  dialogSuctimein.value = true

  closeDialog()
}

onMounted(async () => {
  await checkworkStore.getCheckworks()
  await roleStore.getRoles()
  getCurrentDateTime()
  getCurrentDate()
  setInterval(() => {
    getCurrentDateTime()
    getCurrentDate()
  }, 1000)
})

const filteredCheckworks = computed(() => {
  const currentUserID = authStore.getCurrentUser()?.email
  // กรองเฉพาะข้อมูลที่มี ID เท่ากับ currentUserID
  return checkworkStore.checkworks.filter((checkwork) => checkwork.fullname === currentUserID)
})

function fillFullname() {
  checkworkStore.editedCheckWork.fullname = authStore.getCurrentUser()?.email || ''
}

function fillDate() {
  const today = new Date().toISOString().slice(0, 10)
  checkworkStore.editedCheckWork.date = today
}

function storeCurrentTimein() {
  const currentTime = new Date().toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })
  checkworkStore.editedCheckWork.timein = currentTime
}

function storeCurrentTimeOut() {
  const currentTime = new Date().toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })
  checkworkStore.editedCheckWork.timeout = currentTime
}

function getCurrentDateTime() {
  const now = new Date()
  const year = String(now.getFullYear())
  const month = String(now.getMonth() + 1).padStart(2, '0')
  const day = String(now.getDate()).padStart(2, '0')
  const hours = String(now.getHours()).padStart(2, '0')
  const minutes = String(now.getMinutes()).padStart(2, '0')
  const seconds = String(now.getSeconds()).padStart(2, '0')
  currentTime.value = `${day}-${month}-${year} ${hours}:${minutes}:${seconds}`
}

function getCurrentDate() {
  const now = new Date()
  const year = String(now.getFullYear())
  const month = String(now.getMonth() + 1).padStart(2, '0')
  const day = String(now.getDate()).padStart(2, '0')
  currentDate.value = `${day}/${month}/${year}`
}

async function checkTimeoutAndProceed() {
  const currentUserEmail = authStore.getCurrentUser()?.email

  if (currentUserEmail) {
    const currentUserData = checkworkStore.checkworks
      .filter((item) => item.fullname === currentUserEmail)
      .pop()

    if (currentUserData) {
      if (currentUserData.timeout) {
        console.log('มีข้อมูล timeout สำหรับผู้ใช้งานนี้แล้ว')
        dialoghavetimeinandtimeout.value = true
      } else {
        console.log('ไม่มีข้อมูล timeout ในช่องล่าสุด')

        const currentTime = new Date().toLocaleTimeString([], {
          hour: '2-digit',
          minute: '2-digit'
        })
        currentUserData.timeout = currentTime

        const timein = new Date(currentUserData.timein).getTime()
        const timeout = new Date(currentUserData.timeout).getTime()
        const differenceInHours = (timeout - timein) / (1000 * 60 * 60)

        if (differenceInHours >= 8 && differenceInHours < 9) {
          console.log('Ok')
          currentUserData.status = 'Ok' // กำหนดค่า status โดยตรง
          await editItem(currentUserData)
          // Set a flag or trigger an action indicating normal work hours
        } else if (differenceInHours >= 9) {
          console.log('OT')
          currentUserData.status = 'OT' // กำหนดค่า status โดยตรง
          await editItem(currentUserData)
          // Set a flag or trigger an action indicating overtime
        } else {
          console.log('Fill')
          currentUserData.status = 'Fill' // กำหนดค่า status โดยตรง
          await editItem(currentUserData)
          // Set a flag or trigger an action indicating to fill the time
        }

        storeCurrentTimeOut()
        await save()
      }
    } else {
      console.log('ไม่พบข้อมูลสำหรับผู้ใช้งานนี้ในตาราง')
      dialogNothavetimein.value = true
    }
  } else {
    console.log('ไม่พบข้อมูลผู้ใช้งาน')
  }
}

async function checkTimeinAndProceed() {
  // รับอีเมลของผู้ใช้ปัจจุบัน
  const currentUserEmail = authStore.getCurrentUser()?.email

  if (currentUserEmail) {
    // กรอง checkworks เพื่อค้นหารายการล่าสุดสำหรับผู้ใช้ปัจจุบันในวันที่ปัจจุบัน
    const currentUserData = checkworkStore.checkworks
      .filter(
        (item) =>
          item.fullname === currentUserEmail && item.date === new Date().toISOString().slice(0, 10)
      )
      .pop()

    if (currentUserData) {
      console.log('ผู้ใช้งานได้ทำการ Check-in วันนี้แล้ว')
      dialog.value = false
      dialogEr.value = true
    } else {
      console.log('ผู้ใช้งานยังไม่ได้ทำการ Check-in วันนี้')

      // กำหนดเวลาปัจจุบันเป็นเวลา Check-in
      const currentTime = new Date().toLocaleTimeString([], { hour: '2-digit', minute: '2-digit' })

      // สร้างวัตถุ Checkwork ใหม่
      const newCheckwork = {
        fullname: currentUserEmail,
        password: '',
        date: new Date().toISOString().slice(0, 10),
        timein: currentTime,
        timeout: ''
      }

      // บันทึกวัตถุ Checkwork ใหม่
      // storeCurrentTimein();
      // await save();
      console.log('บันทึกเวลา Check-in เรียบร้อยแล้ว')
    }
  } else {
    console.log('ไม่มีผู้ใช้งานเข้าสู่ระบบ')
  }
}

const dialogCheckworkTime = ref(false)

const closeCheckworkTimeDialog = () => {
  dialogCheckworkTime.value = false
}
</script>
<template>
  <div>
    <v-data-table :headers="headers" :items="filteredCheckworks">
      <template v-slot:top>
        <v-toolbar flat>
          <v-toolbar-title>Checkworks</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="primary" @click="historydate = true"> History </v-btn>
              <v-btn color="primary" v-bind="props"
                @click="fillFullname(); fillDate(); storeCurrentTimein(); checkTimeinAndProceed();">
                Check In
              </v-btn>
              <v-btn color="primary" @click="fillFullname(); fillDate(); checkTimeoutAndProceed();">
                Check Out
              </v-btn>
            </template>


            <v-card>
              <v-col cols="auto" class="d-flex justify-center">
                {{ 'ID: ' + (authStore.getCurrentUser()?.id || '') }}<br />
                {{ 'Name: ' + (authStore.getCurrentUser()?.fullName || '') }}<br />
                {{ 'Role: ' + (authStore.getCurrentUser()?.position || '') }}<br />
                {{ 'Email: ' + (authStore.getCurrentUser()?.email || '') }}<br />
                {{ 'Timestamp: ' + currentTime }}
              </v-col>
              <v-col cols="auto" class="d-flex justify-center">
                <v-btn size="x-large" @click="save()">กดเพื่อเช็คชื่อเวลาเข้างาน</v-btn>
              </v-col>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4" v-show="!checkworkStore.editedCheckWork.fullname">
                        <v-text-field v-model="checkworkStore.editedCheckWork.fullname" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Fullname"></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="4" v-show="!checkworkStore.editedCheckWork.date">
                        <v-text-field v-model="checkworkStore.editedCheckWork.date" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="Date "
                          type="Date"></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="4" v-show="!checkworkStore.editedCheckWork.timein &&
      !checkworkStore.editedCheckWork.timeout
      ">
                        <v-text-field v-model="checkworkStore.editedCheckWork.timein" :readonly="loading" class="mb-2"
                          clearable label="TimeIn"></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="4"> </v-col>
                    </v-row>
                  </v-container>
                </v-form>
              </v-card-text>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>

      <template v-slot:no-data>
        <v-btn color="primary" @click="checkworkStore.getCheckworks"> Reset </v-btn>
      </template>
    </v-data-table>
    <v-dialog v-model="dialogCheckworkTime" persistent width="1024">
      <v-card>
        <v-card-title>
          <span class="text-h5">Checkwork Time</span>
        </v-card-title>
        <v-card-text>
          <!-- Virtual Data Table -->
          <v-data-table-virtual :virtualHeaders="headers" :items="filteredCheckworks" height="400"
            item-value="id"></v-data-table-virtual>
        </v-card-text>
        <v-card-actions>
          <v-btn color="blue-darken-1" variant="text" @click="closeCheckworkTimeDialog()">
            Close
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
  <div class="text-center pa-4">
    <v-dialog v-model="dialogEr" width="auto">
      <v-card max-width="400" prepend-icon="mdi-alert-circle" text="วันนี้ผู้ใช้นี้ได้ลงชื่อเข้างานไปเเล้ว"
        title="แจ้งเตือน">
        <template v-slot:actions>
          <v-btn class="ms-auto" text="Ok" @click="dialogEr = false"></v-btn>
        </template>
      </v-card>
    </v-dialog>
  </div>
  <div class="text-center pa-4">
    <v-dialog v-model="dialogSuctimein" width="auto">
      <v-card max-width="400" prepend-icon="mdi-alert-circle" text="เสร็จสิ้น" title="แจ้งเตือน">
        <template v-slot:actions>
          <v-btn class="ms-auto" text="Ok" @click="dialogSuctimein = false"></v-btn>
        </template>
      </v-card>
    </v-dialog>
  </div>
  <div class="text-center pa-4">
    <v-dialog v-model="dialogNothavetimein" width="auto">
      <v-card max-width="400" prepend-icon="mdi-alert-circle" text="วันนี้ท่านยังไม่ลงชื่อเข้างาน" title="แจ้งเตือน">
        <template v-slot:actions>
          <v-btn class="ms-auto" text="Ok" @click="dialogNothavetimein = false"></v-btn>
        </template>
      </v-card>
    </v-dialog>
  </div>
  <div class="text-center pa-4">
    <v-dialog v-model="dialoghavetimeinandtimeout" width="auto">
      <v-card max-width="400" prepend-icon="mdi-alert-circle" text="วันนี้ท่านลงชื่อเข้างานเเล้วออกงานไปเเล้ว"
        title="แจ้งเตือน">
        <template v-slot:actions>
          <v-btn class="ms-auto" text="Ok" @click="dialoghavetimeinandtimeout = false"></v-btn>
        </template>
      </v-card>
    </v-dialog>
  </div>
  <div>
    <v-dialog v-model="historydate" persistent>
      <v-card width="1100" style="margin-left: 180px">
        <v-icon @click="historydate = false" style="font-size: 35px; margin-left: 1250px">mdi-close</v-icon>
        <h1>Checkwork History</h1>
        <br />
        <v-row>
          <div>
            <v-col cols="5">
              <v-card width="400" style="margin-right: 80px">
                <v-date-picker elevation="24" v-model="date" width="400"></v-date-picker>
              </v-card>
            </v-col>
            <v-col cols="6"> </v-col>
          </div>
        </v-row>
        <v-row>
          <v-col cols="10"></v-col>
          <v-col cols="2">
            <v-btn @click="historydate = false" width="150px" color="red" class="mt-1">cancel
              <v-icon>mdi-close</v-icon></v-btn>
          </v-col>
        </v-row>
      </v-card>
    </v-dialog>
  </div>
</template>
